import clojure.lang.*;
import java.util.concurrent.*;

public class AccountService {
  public static void transfer(final Account from, final Account to, final int amount) {
    try {
      LockingTransaction.runInTransaction(new Callable<Void>() {
        public Void call() throws Exception {
          System.out.println("transfering " + amount);
          to.deposit(amount);
          from.withdraw(amount);        
          return null;
        }
      });      
    } catch(Exception ex) {
      System.out.println(ex.getMessage());
    }
  }
}
